<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1, shrink-to-fit=no"
    />
    <title>Document</title>
    <link
      rel="stylesheet"
      href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css"
      integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn"
      crossorigin="anonymous"
    />
  </head>
  <body>
    <h1 class="text-center">Bootstrap Grid System</h1>

    <!-- two-column layout -->
    <h2 class="text-center">Two Column Layout</h2>
    <!-- class container with grid -->
    <!-- <div class="container bg-dark">
      <h3 class="text-center">1:1 Ratio</h3>
      <div class="row text-center text-white">
        <div class="bg-primary p-3 border border-dark col-6">6 Columns</div>
        <div class="bg-danger p-3 border border-dark col-6">6 Columns</div>
      </div>
    </div> -->

    <div class="container-fluid bg-secondary mt-3">
      <h3 class="text-center">1:1 Ratio</h3>
      <div class="row text-center text-white">
        <div class="bg-primary p-3 border border-dark col-6">6 Columns</div>
        <div class="bg-danger p-3 border border-dark col-6">6 Columns</div>
      </div>
      <h3 class="text-center">1:2 Ratio</h3>
      <div class="row text-center mt-3">
        <div class="bg-info border border-dark col-4 p-3">4 Col</div>
        <div class="bg-warning border border-dark col-8 p-3">8 Col</div>
        <!-- if the number of columns in a row exceeds 12, the next div will overflow to the next line. -->
        <div class="bg-success border border-dark col-3 p-3">3 Col</div>
      </div>
    </div>

    <!-- 
      Bootstrap grid system runs on a rule of crc 
        Container - sets the max width of the grid system
        Row - holds 12 columns that are equally divided 
        Column - where content will be added
     -->

    <!-- three columns -->
    <h2 class="text-center my-5">Three Column Layout</h2>
    <div class="container-fluid bg-secondary">
      <h3 class="text-center">1:1:1 Ratio</h3>
      <div class="row text-center">
        <div class="col-4 bg-info border border-dark p-3">4 Col</div>
        <div class="col-4 bg-warning border border-dark p-3">4 Col</div>
        <div class="col-4 bg-success border border-dark p-3">4 Col</div>
      </div>
      <h3 class="text-center">Uneven Columns</h3>
      <div class="row text-center">
        <div class="col-5 bg-primary border border-dark p-3">5 Col</div>
        <div class="col-4 bg-danger border border-dark p-3">4 Col</div>
        <div class="col-3 bg-success border border-dark p-3">3 Col</div>
      </div>
    </div>

    <!-- columns with content -->
    <h2 class="text-center my-5">Column with Sample Content</h2>
    <div class="container-fluid bg-dark">
      <div class="row">
        <div class="col-6 p-3 text-white">
          <h3>Sample Content</h3>
          <p class="mt-2">
            Lorem ipsum dolor sit amet consectetur adipisicing elit. Lorem
            ipsum, dolor sit amet consectetur adipisicing elit. Soluta, ducimus.
          </p>
        </div>
        <div class="col-6 p-3">
          <img
            src="https://place-puppy.com/1000x1000"
            alt="Photo of a puppy"
            class="img-fluid"
          />
        </div>
      </div>
    </div>

    <!-- MINI ACTIVITY -->
    <h3 class="text-center my-5">Mini Activity with 3 columns</h3>
    <div class="container-fluid">
      <div class="row">
        <div class="col-5">
          <h3 class="text-center">
            This text's column is bigger than the picture
          </h3>
        </div>
        <div class="col-2">
          <img
            src="https://placebear.com/500/500"
            alt="Photo of a bear"
            class="img-fluid"
          />
        </div>
        <div class="col-5">
          <p>This text's column is bigger than the picture</p>
        </div>
      </div>
    </div>

    <!-- AUTO COLUMNS -->
    <h2 class="my-5 text-center">Auto Columns</h2>
    <!-- to add the number of columns a div in a row can occupy the syntac of the bootstrap class is this: col-(# of cols) -->
    <div class="container-fluid bg-secondary">
      <div class="row">
        <!-- when creating a column but not providing the total number of grid columns to occupy, bootstrap will then assign and calculate the total number of columns left in the row and assign it per auto column accordingly -->
        <div class="bg-danger border border-dark p-3 col">Auto 1</div>
        <div class="bg-success border border-dark p-3 col">Auto 2</div>
        <div class="bg-info border border-dark p-3 col">Auto 3</div>
        <div class="bg-success border border-dark p-3 col">Auto 4</div>
        <div class="bg-light border border-dark p-3 col">Auto 5</div>
        <div class="bg-secondary border border-dark p-3 col">Auto 6</div>
        <div class="bg-primary border border-dark p-3 col">Auto 7</div>
      </div>
      <div class="row my-5">
        <div class="col-6 bg-primary border border-dark">Col 6</div>
        <div class="col bg-success border border-dark">Auto</div>
        <div class="col bg-info border border-dark">Auto</div>
        <div class="col bg-danger border border-dark">Auto</div>
      </div>
    </div>

    <!-- BREAKPOINTS AND COLUMNS -->
    <h2 class="my-5 text-center">Breakpoints and Columns</h2>
    <div class="container-fluid bg-dark">
      <div class="row">
        <!-- 
          by default a column will occupy 12 columns, until its breakpoint. A bp is the screen or screen size wherein the number of columns given will take effect
         -->
        <div class="col-lg-6 bg-danger border border-dark p-3">
          6 Cols in lg, 12 cols in xs
        </div>
        <!-- declaring or adding col without bp means that this div has 6 cols from the smallest screen to the largest  -->
        <div class="col-6 bg-primary border border-dark p-3">
          6 cols all screens
        </div>
      </div>
      <div class="row my-5">
        <!-- Cols wihout bp means the number of cols from the smallest screen until the bp. From the bp, lg, this div is now 8 cols. -->
        <div class="col-3 col-lg-8 bg-info border border-dark p-3">
          col-lg-8
        </div>
        <!-- Without setting the number of cols from the smallest screen, by default, the column will occupy 12 columns until bp. -->
        <div class="col-md-4 bg-warning border border-dark p-3">col-md-4</div>
      </div>
      <!-- 
        Breakpoints: 
        - you can set the numbr of cols a div occupies per screen using bp
        - by default fro smallest screen a div with class col will occupy 12 cols 
          - this is because bootstrap is a mobile first approach to styling a webpage so the default bp is for the smallest screen 
          - until you add a bp (sm, md, lg, xl) the number of cols a div will occupy will be the same from the smallest to the largest screen

        cols can be sized with bp starting from the smallest screen:
          col-* - from the smallest screen
          col-sm-* - bp from small screen or about 576px screen width
          col-md-* - bp from the medium sceen or tablet or about 768px screen width
          col-lg-* - bp from the large screen or laptop or about 992px screen width
          col-xl-* - bp from the largest screen or 1200px screen width 
      -->
      <h3 class="text-center my-5">Mini Activity with Breakpoints</h3>
      <div class="row mb-5">
        <div class="col-6 bg-primary border border-dark p-3">Div 1</div>
        <div class="col-6 col-md-10 bg-danger border border-dark p-3">
          Div 2
        </div>
      </div>
      <div class="row">
        <div class="col-md-8 bg-success border border-dark p-3">Div 1</div>
        <div class="col-6 col-md-2 bg-info border border-dark p-3">Div 2</div>
        <div class="col-6 col-md-2 bg-info border border-dark p-3">Div 3</div>
      </div>

      <!-- Breakpoints with Text Alignment -->
      <h3 class="text-md-center my-5">Text Alignment with Breakpoints</h3>
      <div class="row">
        <div
          class="
            col-6 col-md-8
            text-right text-md-left
            bg-primary
            border border-dark
            p-3
          "
        >
          Div 1
        </div>
        <div
          class="col-6 col-md-4 text-md-right bg-danger border border-dark p-3"
        >
          Div 2
        </div>
      </div>

      <h2 class="text-center my-5">Display Order with Breakpoints</h2>
      <div class="row">
        <div
          class="
            col-6 col-md-10
            order-2 order-md-1
            bg-warning
            border border-dark
            p-3
          "
        >
          Div 1
        </div>
        <div
          class="
            col-6 col-md-2
            order-1 order-md-2
            bg-primary
            border border-dark
            p-3
          "
        >
          Div 2
        </div>
      </div>
      <h3 class="text-md-center my-5">Mini Activity with Order</h3>
      <div class="row">
        <div
          class="
            col-4
            order-1 order-md-2 order-lg-3
            bg-warning
            border border-dark
            p-3
          "
        >
          Lebron
        </div>
        <div
          class="
            col-4
            order-3 order-md-1 order-lg-2
            bg-primary
            border border-dark
            p-3
          "
        >
          Curry
        </div>
        <div
          class="
            col-4
            order-2 order-md-3 order-lg-1
            bg-secondary
            border border-dark
            p-3
            text-white
          "
        >
          Durant
        </div>
      </div>
    </div>

    <!-- *** JS DEPENDENCIES *** -->
    <script
      src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js"
      integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js"
      integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF"
      crossorigin="anonymous"
    ></script>
  </body>
</html>
